precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform vec2 canvasSize;
uniform vec2 inputSize;
uniform int mode;//0 repeat, 1 mirrored repeat,2 clamp to edge, 3 clamp to border(black)

vec4 getOutColor(vec2 uv, int mode) {
    vec4 color = vec4(0.0);
    if(mode == 0) {
        uv = fract(uv);
        color = texture2D(inputImageTexture, uv);
    } else if(mode == 1) {
        uv += 1.0;
        uv *= 0.5;
        uv = fract(uv);
        uv = abs((uv-0.5) * 2.0);
        color = texture2D(inputImageTexture, uv);
    } else if(mode == 2){
        color = texture2D(inputImageTexture, uv);
    } else {
        if(uv.x < 0.0 || uv.x > 1.0 || uv.y < 0.0 || uv.y > 1.0) {
            color = vec4(vec3(0.0), 0.0);
        } else {
            color = texture2D(inputImageTexture, uv);
        }
    }
    return color;
}

void main()
{
    vec2 uv = textureCoordinate;
    uv.x *= canvasSize.x / inputSize.x;
    uv.y *= canvasSize.y / inputSize.y;
    gl_FragColor = getOutColor(uv, mode);
}