precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D maskTexture;
uniform sampler2D backgroundTexture;
uniform float effectValue;
void main()
{
    vec2 uv = textureCoordinate;
    vec4 srcCol = texture2D(inputImageTexture, uv);
    vec4 backCol = texture2D(backgroundTexture, uv);
    vec4 maskCol = texture2D(maskTexture, uv);
    vec4 resultColor =  mix(srcCol,backCol, maskCol.r * effectValue);
    gl_FragColor = resultColor;
}