precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float fillTransparency;
uniform float threshold;
uniform float tolerance;

float lum(vec4 color) {
    return dot(color.rgb, vec3(0.2126, 0.7152, 0.0722));
}

void main()
{
    vec2 uv = textureCoordinate;
    vec4 col = texture2D(inputImageTexture, uv);
    if(threshold > 0.001) {
        float gray = lum(col);
        if(abs(gray - threshold) <= tolerance) {
            col = mix(col, vec4(1.0), fillTransparency);
        }
    }
    gl_FragColor = col;
}