precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float threshold;

float lum(vec4 color) {
    return dot(color.rgb, vec3(0.2126, 0.7152, 0.0722));
}

void main()
{
    vec2 uv = textureCoordinate;
    vec4 col = texture2D(inputImageTexture, uv);
    float gray = lum(col);
    if(gray >= threshold) {
        col = texture2D(inputImageTexture, uv);
    } else {
        col = vec4(vec3(0.0), col.a);
    }
    gl_FragColor = col;
}