precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform highp float iTime;
uniform highp float effectValue;

#define M_PI_2_F 3.142592653

vec2 clampUV(vec2 uv){
    vec2 huv = uv;
    if(huv.y > 1.0 || huv.y < 0.){
        //multi mirror
        //int index = int(floor(huv.y));
        huv.y = mod(floor(huv.y),2.0) != 0.0 ? 1.0 - huv.y : huv.y;
    }
    if(huv.x > 1.0 || huv.x < 0.){
        //int index = int(floor(huv.x));
        huv.x = mod(floor(huv.x),2.0) != 0.0 ? 1.0 - huv.x : huv.x;
    }
    return huv;
}

void main() {
    vec2 uv = textureCoordinate;
    vec2 dt = vec2(0.0, 0.0);
    vec2 uniA = vec2(100.0,100.0);
    vec2 uniB = vec2(1.0,1.0);
    vec2 uniScale = vec2(0.02,0.01);
    float maxMoveDis = 0.04;
    uniScale.x = sin(iTime *maxMoveDis* uniA.x + uniB.x)* 0.01;
    uniScale.y = cos(iTime*0.9 *maxMoveDis * uniA.y + uniB.y) * 0.01;
    dt.x = cos(sin(iTime *maxMoveDis* uniA.x + uniB.x)*M_PI_2_F )* uniScale.x;
    dt.y = sin(cos(iTime *maxMoveDis * uniA.y + uniB.y)*M_PI_2_F) * uniScale.y;
    uv = uv+dt;
    uv = clampUV(uv);
    vec4 result = texture2D(inputImageTexture,fract(uv));
    gl_FragColor = result;
}